name: Build and Publish Docker Image

on:
  push:
    branches: [ "main" ]

jobs:
  build:
    runs-on: ubuntu-latest
    steps:
      - name: Checkout repository
        uses: actions/checkout@v4

      - name: Log in to Gitea Container Registry
        uses: docker/login-action@v3
        with:
          registry: ${{ gitea.server_url }}
          username: ${{ gitea.actor }}
          password: ${{ secrets.PAT }}

      - name: Build and push Docker image
        uses: docker/build-push-action@v5
        with:
          context: .
          push: true
          tags: |
            git.toomuchtaco.net/${{ gitea.repository }}:latest
            git.toomuchtaco.net/${{ gitea.repository }}:${{ gitea.sha }}


      - name: Pull and Redeploy Komodo Stack
        run: |
          curl --header "Content-Type: application/json" \
               --header "X-Api-Key: ${{ secrets.KOMODO_API_KEY }}" \
               --header "X-Api-Secret: ${{ secrets.KOMODO_API_SECRET }}" \
               --data '{ "stack": "${{ secrets.KOMODO_STACK }}" }' \
               ${{ secrets.KOMODO_HOST }}/execute/PullStack
          curl --header "Content-Type: application/json" \
               --header "X-Api-Key: ${{ secrets.KOMODO_API_KEY }}" \
               --header "X-Api-Secret: ${{ secrets.KOMODO_API_SECRET }}" \
               --data '{ "stack": "${{ secrets.KOMODO_STACK }}" }' \
               ${{ secrets.KOMODO_HOST }}/execute/DeployStack